//=============================================================================
// Two-Way Linear List Class Library
// Copyright(c)1999 Yamamoto Takanori.
//=============================================================================
#include <stdio.h>
#include <stdlib.h> // for NULL
#include "ezlist.h"


//CONSTRUCTOR
ezlist::ezlist()
{
  alpha.prev = NULL; alpha.next = &omega; alpha.data = NULL;
  omega.prev = &alpha; omega.next = NULL; omega.data = NULL;
}

//DESTRUCTOR
ezlist::~ezlist()
{
  ezatom *ptr;
  this->gofirst(&ptr);
  this->forward(&ptr);
  while(!(remove(&ptr))){};
}

int ezlist::gofirst(ezatom **ptr)
{
  (*ptr) = &alpha;
  return 0;
}

int ezlist::golast(ezatom **ptr)
{
  (*ptr) = &omega;
  return 0;
}

int ezlist::forward(ezatom **ptr)
{
  (*ptr) = ((*ptr)->next);
  if((*ptr) == &omega){return -1;}else{return 0;}
}

int ezlist::backward(ezatom **ptr)
{
  (*ptr) = ((*ptr)->prev);
  if((*ptr) == &alpha){return -1;}else{return 0;}
}

int ezlist::append(const char *src, int len)
{
  ezatom *atom = (ezatom *)malloc(sizeof(ezatom));
  (atom->data) = (char *)malloc(len);
  for(int n=0; n<len; n++){(atom->data)[n] = src[n];}
  atom->prev = omega.prev;
  atom->next = &omega;
  (omega.prev)->next = atom;
  omega.prev = atom;
  return 0;
}

int ezlist::remove(ezatom **ptr)
{
  ezatom *tmp;
  if((*ptr) == &alpha){return -1;}
  if((*ptr) == &omega){return 1;}
  tmp = ((*ptr)->prev)->next = (*ptr)->next;
  ((*ptr)->next)->prev = (*ptr)->prev;
  free((*ptr)->data); free(*ptr);
  *ptr = tmp;
  return 0;
}

char *ezlist::getdata(ezatom **ptr)
{
  return((*ptr)->data);
}


