//=============================================================================
// Serial Communication Class Library
// Copyright(c)1999 Yamamoto Takanori.
//=============================================================================
#ifndef _H_SERIAL_
#define _H_SERIAL_

#include "ezring.h"
#include <termios.h> // for bps

class serial{
  int fd;
  ezring ring;
  int ms;
  int flag_timeout;
  void (*callbackfunc_timeout)(void);
  int init(int bps);
 public:
  serial(int bufsize=65536);
  ~serial();
  int open(const char *siodev, int bps=B9600);
  int close(void);
  int read(char *str, int len);//with timeout
  int read_until(char *str, int len, char c);
  int write(const char *str, int len);
  int setbufsize(int size);
  int getbufsize(void);
  int settimeout(int val);
  int gettimeout(void);
  int setcallbackfunc_timeout(void (*f)(void));
};

#endif /* _H_SERIAL_ */
